"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BooleanType = void 0;
const boolean_js_1 = require("../../flags/types/boolean.js");
const type_js_1 = require("../type.js");
/** Boolean type with auto completion. Allows `true`, `false`, `0` and `1`. */
class BooleanType extends type_js_1.Type {
    /** Parse boolean type. */
    parse(type) {
        return (0, boolean_js_1.boolean)(type);
    }
    /** Complete boolean type. */
    complete() {
        return ["true", "false"];
    }
}
exports.BooleanType = BooleanType;
