"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.boolean = void 0;
const _errors_js_1 = require("../_errors.js");
/** Boolean type handler. Excepts `true`, `false`, `1`, `0` */
const boolean = (type) => {
    if (~["1", "true"].indexOf(type.value)) {
        return true;
    }
    if (~["0", "false"].indexOf(type.value)) {
        return false;
    }
    throw new _errors_js_1.InvalidTypeError(type, ["true", "false", "1", "0"]);
};
exports.boolean = boolean;
