import { UnityChangeset as UnityChangesetClass } from "./unityChangeset.js";
export declare const UnityChangeset: typeof UnityChangesetClass;
export type UnityChangeset = UnityChangesetClass;
export declare function getUnityChangeset(db: string, version: string): Promise<UnityChangeset>;
export declare function loadDb(db: string, version?: string): Promise<UnityChangeset[]>;
export declare enum SearchMode {
    All = 0,
    Default = 2,
    PreRelease = 3
}
export declare enum GroupMode {
    All = "all",
    OldestPatch = "oldest-patch",
    LatestPatch = "latest-patch",
    LatestLifecycle = "latest-lifecycle"
}
export interface FilterOptions {
    min: string;
    max: string;
    grep: string;
    allLifecycles: boolean;
    lts: boolean;
}
export declare enum OutputMode {
    Changeset = "changeset",
    VersionOnly = "version",
    MinorVersionOnly = "minor-version"
}
export declare enum FormatMode {
    None = "none",
    Json = "json",
    PrettyJson = "pretty-json"
}
export declare function listChangesets(db: string, searchMode: SearchMode, filterOptions: FilterOptions, groupMode: GroupMode, outputMode: OutputMode, formatMode: FormatMode): Promise<string>;
export declare function searchChangesets(db: string, searchMode: SearchMode): Promise<UnityChangeset[]>;
export declare function filterChangesets(changesets: UnityChangeset[], options: FilterOptions): UnityChangeset[];
export declare function groupChangesets(changesets: UnityChangeset[], groupMode: GroupMode): UnityChangeset[];
